/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var helptips = new Array();

helptips["proxyServiceHelpDiv"] = "Proxy services define virtual services hosted on the ESB that "
        + "can accept requests, mediate them, and deliver them to the actual service. Proxy "
        + "services perform transport switching and expose different semantics than the actual "
        + "service, i.e., WSDL, policies, and QoS aspects like WS-RM, WS-Security, etc.";

helptips["serverInfoHelpDiv"] = "<p class='normalHelpBody'>Information about the WSO2 ESB instance"
        + "managed by this console.</p>";

helptips["endpointHelpDiv"] = "An endpoint is a specific destination for a message. It may be "
        + "specified as an Address endpoint, WSDL endpoint, a Failover group, or a Load balance "
        + "group. Endpoints can be added, edited, and deleted using this page. Note that any "
        + "endpoints used in Failover and Load balance endpoints cannot be deleted. You can also "
        + "enable statistics for Address and WSDL endpoints.";

helptips["sequencesHelpDiv"] = "A sequence element is used to define a sequence of mediators that "
        + "can be invoked later as a sequence. If the configuration defines a sequence named main, "
        + "then it is considered as the main mediation sequence of the ESB. If such a sequence is "
        + "not defined locally, and a registry has been specified, the registry is looked up for a "
        + "key named \"main\" to find the main mediator sequence. The main and fault sequences "
        + "have already been added to the default configuration.";

helptips["entryHelpDiv"] = "The local registry entries are used to locally define resources such "
        + "as scripts, schemas, WSDLs, policies and other resources in a configuration. They are "
        + "not uploaded or fetched from the Integrated Registry. They are static. An entry that "
        + "exists in the local registry has higher precedence over an entry with the same name "
        + "that exists in the integrated registry.";

helptips["configHelpDiv"] = "Displays the current ESB configuration in the XML based WSO2 ESB "
        + "configuration language. You can persist this configuration so that it will be loaded "
        + "automatically when the ESB is restarted. You can also make manual changes to the "
        + "configuration using this page. Note that such manual changes should comply with the "
        + "ESB configuration language.";

helptips["registryManagementHelpDiv"] = "The registry provides a mechanism of creating and storing "
        + "configuration elements outside the ESB. These registry contents can be dynamically "
        + "loaded or modified, which will allow runtime modification of the ESB behaviors. The "
        + "folder structure gives a clear view of the available files and easy access to modifying "
        + "the files. Once these files are loaded, their content are cached in the ESB for the "
        + "specified duration, and is updated at the end of the caching period.";

helptips["systemInfoDiv"] = "Displays information about the operating system, server name, Axis2 "
        + "location, repository location and other information about the system.";

helptips["statisticsHelpDiv"] = "Displays statistics of the server, proxy service, endpoints, and "
        + "sequences. The statistics are generated only if the Enable Statistics option is active. "
        + "This page is automatically updated every minute. The statistics consists of the number "
        + "of requests, fault count, and response times of the messages and services.";

helptips["logsHelpDiv"] = "Displays the log messages generated by the system. You can view "
        + "messages by categaries and search messages using this page.";

helptips["traceHelpDiv"] = "Displays trace messages generated by the components of the system, "
        + "while processing messages. Trace messages contain detailed actions performed by various "
        + "components along the message path. Note that traces are generated only by the "
        + "components in which tracing is enabled.";

// todo: more helps to be filled

function showHelp(oEvent, divID) {

    var browsername = navigator.appName;
    var oDiv = null;
    try {
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            if (divID instanceof  HTMLDivElement) {
                oDiv = divID;
            }
            else {
                oDiv = document.getElementById(divID);
            }
        }
        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            oDiv = document.getElementById(divID);
            if (oDiv == null) {
                oDiv = divID;
            }
        }
    }
    catch(e)
    {
    }
//    oDiv.className = "helptip";
    
    oDiv.style.visibility = "hidden";
    oDiv.innerHTML = "<div class='helpheader'>&nbsp;&nbsp;&nbsp;</div><div class='helpbody'>" + helptips[oDiv.id] + "</div><div class='helpfooter'>&nbsp;&nbsp;&nbsp;</div>";
    if(oDiv.innerHTML == undefined || oDiv.innerHTML == "undefined") {
        oDiv.innerHTML = "<p class='absentHelp'>Contenets for the help is not present</p>"
    }
    oDiv.style.left = oEvent.clientX + 10;
    oDiv.style.top = oEvent.clientY + 10;

    yuioverlay = new YAHOO.widget.Overlay(divID,{visible:true, effect:{effect:YAHOO.widget.ContainerEffect.FADE,duration:1} } );
    yuioverlay.render();
    yuioverlay.show();
}

var yuioverlay;

function hideHelp(oEvent, divID) {
    var oDiv = null;
    var browsername = navigator.appName;
    try {
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            if (divID instanceof  HTMLDivElement) {
                oDiv = divID;
            }
            else {
                oDiv = document.getElementById(divID);
            }
        }
        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            oDiv = document.getElementById(divID);
            if (oDiv == null) {
                oDiv = divID;
            }
        }
    }
    catch(e)
    {
    }

//    oDiv.style.visibility = "hidden";
    yuioverlay.hide();
}

