/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * This js file is for the property mediator specific UI operations
 */

collectdata["property"] = function collectsetpropertydata(mediator, validate) {

    /*************updating the name property*******************************/
    var name = document.getElementById("name").value;
    if (name != "") {
        mediator.setAttribute("name", name);

        var actionElements = document.getElementsByName("action");
        if (actionElements[0].checked) {
            mediator.setAttribute("action", "set");

            var typeElements = document.getElementsByName("type");
            var type;
            if (typeElements.length != 0 && typeElements[0].checked) {
                type = "value";
            } else {
                type = "expression";
            }
            
            var value = "";
            if(document.getElementById("val_ex") != undefined && document.getElementById("val_ex") != null) {
                value = document.getElementById("val_ex").value;
            }
            if (mediator.getAttribute("value") != null) {
                mediator.removeAttribute("value");
            }
            if (mediator.getAttribute("expression") != null) {
                mediator.removeAttribute("expression");
            }
            if (value != "") {
                mediator.setAttribute(type, value);
            } else if (!validate) {
                esbwarning("The value or expression must be specified for the property mediator", TYPE_INFO);
                return false;
            }

            var scope_element = document.getElementById("scope");
            if(scope_element != undefined && scope_element != null) {
                var scope_index = scope_element.selectedIndex;
                var scope = scope_element.options[scope_index].value;
                if (scope != "synapse") {
                    mediator.setAttribute("scope", scope);
                }
            }
            
        } else {
            mediator.setAttribute("action", "remove");
        }
        
    } else if(!validate) {
        esbwarning("Property name must be specified", TYPE_INFO);
        return false;
    }
    return true;
};

function setPropertyAction(action) {
    
    var position = geteditingmediatorposition();

    var mediator = getnestedmediator(internalmodel.sequence, position);

    collectdata["property"](mediator, true);
    mediator.setAttribute("action", action);

    editmediator(position);
}

function setPropertyExpr(position) {

    var medposition = geteditingmediatorposition();

    var mediator = getnestedmediator(internalmodel.sequence, medposition);

    collectdata["property"](mediator, true);
    mediator.removeAttribute("value");
    mediator.setAttribute("expression", "");

    editmediator(position);

    showNamespaceButton(position,'','','namespaceButtonCell','true');
}

function setPropertyValue(position) {

    var medposition = geteditingmediatorposition();

    var mediator = getnestedmediator(internalmodel.sequence, medposition);

    collectdata["property"](mediator, true);
    mediator.removeAttribute("expression");
    mediator.setAttribute("value", "");

    editmediator(position);
}