/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * This js file is for the log mediator specific UI operations
 */

collectdata["xslt"] = function collectlogdata(mediator, validate) {

    var key = document.getElementById("xslt_key");
    if (key != null && key.value != null && key.value != "") {
        mediator.setAttribute("key", key.value);
        var source = document.getElementById("xslt_source");
        if (source != null && source.value != null && source.value != "") {
            mediator.setAttribute("source", source.value);
        }
    } else if(!validate) {
        esbwarning("XSLT registry key to be used for the transformation must be specified", TYPE_INFO);
        return false;
    }

    collectproppertydata(mediator);

    return true;
};

function xsltkeyfromregistry(index){
    var panelId = ("mypanel" + index).toString();
    registrybrowser("savexsltkeyfromregistry", "dicardregistrybrowser", index, 1, panelId);
}
function savexsltkeyfromregistry(position) {
    var mediator = getnestedmediator(internalmodel.sequence, position);
    collectdata[mediator.nodeName.substring(mediator.nodeName.indexOf(":") + 1, mediator.nodeName.length)](mediator, true);
    var regKey = getRegistryKey();
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        mediator.setAttribute("key", regKey);
    }
    var epdiv = document.getElementById("ep");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/xslt_edit.xsl", epdiv);
    }
}

mediatorelementstring["xslt"] = function logstring() {
    return "<syn:xslt xmlns:syn='http://ws.apache.org/ns/synapse'/>";
};
