/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var browsername = navigator.appName;

var globalIndex = "";
var keyPath = new Array();
var fillOnly = "false";
var globalCurrentParent = "";

var EXPANDED = "EXPANDED";
var COLLAPSED = "COLLAPSED";
var NOT_AVAILABLE = "NOT_AVAILABLE";
var expandedImg = new Image();
expandedImg.src = "extensions/core/images/tree_opened.gif";

var collapsedImg = new Image();
collapsedImg.src = "extensions/core/images/tree_closed.gif";

var foldercloseImg = new Image();
foldercloseImg.src = "extensions/core/images/folder_close.gif"

var folderopenImg = new Image();
folderopenImg.src = "extensions/core/images/folder_open.gif"

var fileImg = new Image();
fileImg.src = "extensions/core/images/file.gif"

var thisObject = null;

/* root class */

function root(registryDiv, pName){

    // attributes

    this.name = pName;
    this.np = pName.substring(0,1); // prefix used for div names
    this.rootChildren = new Array();
    this.regDivName = registryDiv;

    //this.regDataDivName = regDataDiv;
    this.selected = null;
    this.populatedFolders = new Array();
    this.currentParent = null;

    /*
    user of the root can register a call back function which takes the selected folder path
    as the parameter
    */
    this.folderSelectHandler = null;

    // methods

    this.fillAndExpand = fillAndExpandFolder;
    this.add = addRootChild;
    this.write = writeRoot;
    this.getSelected = getSelectedValue;
    this.addFolder = addNewFolder;
    this.getFolder = getFolderOfTree;
    this.getMatchingChild = getMatchingRootChild;
    this.expand = expandRootFolder;
    this.collapse = collapseRootFolder;
    this.collapseFolder = collapseGivenFolder;
    this.show = showRoot;
    this.expanderClick = onExpanderClick;
    this.populateChildren = populateChildrenRoot;
    //this.populateChildrenCallback = populateChildrenCallbackRoot;
    this.containsString = containsStringRoot;
    this.onFolderClick = onFolderClickRoot;
    this.registerFolderSelectHandler = registerFolderSelectHandlerRoot;
    this.reset = resetRoot;
    //this.showFolder = showFolderRoot;
    //this.hideFolder = hideFolderRoot;

    this.test = testRoot;
    thisObject = this;
}

function resetRoot() {

    this.rootChildren = new Array();
    this.selected = null;
    this.populatedFolders = new Array();
    this.currentParent = null;

    this.show();
}

/**
 Display the registry. Expand and highlight the selected value.
 */
function showRoot(selectedValue) {
    this.selected = selectedValue;

    // if root is not populated, populate it
    if(this.containsString(this.populatedFolders, "")) {
        this.expand("");
        this.write();
    } else {
        this.populatedFolders[this.populatedFolders.length] = "";
        fillOnly = "false";
        this.populateChildren("", this.regDivName, "");
    }
}

function fillAndExpandFolder(path) {

    this.rootChildren = new Array();
    this.selected = null;
    this.populatedFolders = new Array();
    this.currentParent = null;

    keyPath = path.split('/');
    fillOnly = "true";
    globalIndex = 0;
    this.populatedFolders[this.populatedFolders.length] = "";
    this.populateChildren("", this.regDivName, "");
}

function getFolderState(folderName) {
    var folder = this.getFolder(folderName);
    if(folder != null) {
        return folder.getState();
    } else {
        return NOT_AVAILABLE;
    }
}

function registerFolderSelectHandlerRoot(selectHandler) {
    this.folderSelectHandler = selectHandler;
}

function collapseGivenFolder(folderName) {
    var folder = this.getFolder(folderName);
    if(folder != null) {
        folder.collapse();
    }
}

/**
 Collapse the folder and all its descendants.
 */
function collapseRootFolder() {

    hideFolder(this.path);
    var numFolders = this.rootChildren.length;
    for (var i=0;i <numFolders;i++) {
        this.rootChildren[i].collapse();
    }
}

/**
 Expands to the specified folder. If successors of the given folder are not expanded we have to
 expand them as well.
 */
function expandRootFolder(folder) {

    var rootFolder = this.getMatchingChild(folder);

    if(rootFolder != null) {
        showFolder(rootFolder.path);
        var expImg = document.getElementById('E' + this.np + folder.path);
        if(expImg != null) {
            expImg.src = expandedImg.src;
        }

        rootFolder.expand(folder);
    }
}

function getMatchingRootChild(path) {

    var currentMatch = null;

    var numFolders = this.rootChildren.length;
    for (var i=0;i <numFolders;i++) {
        if(path.indexOf(this.rootChildren[i].path) == 0) {
            if (currentMatch == null) {
                currentMatch = this.rootChildren[i];
            } else {
                if (currentMatch.path.length < this.rootChildren[i].path.length) {
                    currentMatch = this.rootChildren[i];
                }
            }
        }
    }

    return currentMatch;
}

function addRootChild(folder){
    this.rootChildren[this.rootChildren.length] = folder;
}

function addNewFolder(parent, newFolder) {
    var hookFolder = this.getFolder(parent);
    var childFolder = new folder(parent + '/' + newFolder, newFolder, this.np);
    hookFolder.add(childFolder);
    this.write();
}

function getFolderOfTree(path) {

    var entity = this.getMatchingChild(path);

    if(entity == null) {
        esbwarning("null entity", TYPE_ERROR);
        return null;
    }

    while(entity.path.length != path.length) {

        entity = entity.getMatchingChild(path);

        if(entity == null) {
            return null;
        }
    }

    return entity;
}

function getSelectedValue() {
    return this.selected;
}

function testRoot() {

    //var treeString;
    //var numFolders = this.rootChildren.length;
    //for (var i=0;i <numFolders;i++)
    //    treeString += this.rootChildren[i].write();

    //showStuffInNewWindow(treeString);

    this.expanderClick('wso2esb-1.0-beta-1');
}

function writeRoot(){

    var treeString = "";
    //treeString += '<input type="button" value="test" onClick="this.test()" /><br />';
    var numFolders = this.rootChildren.length;
    for (var i=0;i <numFolders;i++)
        treeString += this.rootChildren[i].write();

    var regElement = document.getElementById(this.regDivName);

    //showStuffInNewWindow(treeString);

    regElement.innerHTML = treeString;

    var selectedEntry = document.getElementById('l' + this.np + this.selected);
    if (selectedEntry != null) {
        selectedEntry.style.backgroundColor = '#9999ff';
    }

    //alertWarning("wrote to: " + this.regDivName);
    //showStuffInNewWindow(treeString);
}

/**
 We might let users to register handlers here. For now let's implement our code.
 */
function onExpanderClick(folderName) {

    var folder = this.getFolder(folderName);
    if(folder != null) {
        if(folder.getState() == EXPANDED) {
            this.collapseFolder(folderName);
        } else if (folder.getState() == COLLAPSED) {
            if(this.containsString(this.populatedFolders, folderName)) {
                this.expand(folderName);
            } else {
                this.populatedFolders[this.populatedFolders.length] = folderName;
                fillOnly = "false";
                this.populateChildren(folderName, this.regDivName, "test");
            }
        }
    }
}

function onFolderClickRoot(folder) {

    var oldEntry = document.getElementById('l' + this.np + this.selected);
    if (oldEntry != null) {
        oldEntry.style.backgroundColor = '#ffffff';
    }

    var newEntry = document.getElementById('l' + this.np + folder);
    if (newEntry != null) {
        newEntry.style.backgroundColor = '#9999ff';
    }

    this.selected = folder;
    this.folderSelectHandler(folder);
}

function populateChildrenRoot(parent, divName, defaultValue) {

    this.currentParent = parent;

    // we have to use a global variable to store the current parent, as this.currentParent member
    // variable is not available for the call back
    globalCurrentParent = parent;

    selectedValue = defaultValue;

    var body_xml = '<ns1:getChildren xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<parent>' + parent + '</parent>' +
                   '</ns1:getChildren>';



    var callURL = serverURL + "/" + "RegistryAdmin" + "/" + "getChildren";

    send("getChildren", body_xml, "", callURL, "", false, populateChildrenCallback);
}

function populateChildrenCallback() {

    if (!onError()) {
        return;
    }

    var registryKeyDiv = document.getElementById(thisObject.regDivName);

    var body;
    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        body = xhReq.responseXML.getElementsByTagName("Body")[0];
    } else {
        body = xhReq.responseXML.getElementsByTagName("soapenv:Body")[0];
    }

    if (body != null) {

        var fault = body.getElementsByTagName("Fault")[0];
        if (fault != null) {
            registryKeyDiv.innerHTML = "<input type='text' id='propertyKey' value='"+selectedValue+"'/>";
        } else {

            var entries = body.getElementsByTagName("regEntry");

            if (entries.length == 0) {
                registryKeyDiv.innerHTML = "<label style='width: 200px; text-align: left'>No registry keys found.</label>";
            } else {

                if(thisObject == null) {

                    // if thisObject is not created parent should always be root
                    // so create a new root and add children to root
                    //thisObject = new root(registryKeyDivName);
                    //var i = 0;
                    //for (i = 0; i < entries.length; i++) {
                    //    var key = entries[i].textContent;
                    //    var child = new folder(key, key);
                    //
                    //    thisObject.add(child);
                    //}

                } else {

                    if (globalCurrentParent == null || globalCurrentParent == "") {

                        // if parent is not set assume that we are adding to the root
                        var i = 0;
                        for (i = 0; i < entries.length; i++) {

                            var key;
                            var type;
                            if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                                key = entries[i].getElementsByTagName("key")[0].textContent;
                                type = entries[i].getElementsByTagName("type")[0].textContent;
                            } else {
                                key = entries[i].getElementsByTagName("key")[0].text;
                                type = entries[i].getElementsByTagName("type")[0].text;
                            }

                            var child;
                            if (type == "folder") {
                                child = new folder(key, key, thisObject.np);
                            } else {
                                child = new regfile(key, key, thisObject.np);
                            }

                            thisObject.add(child);
                        }

                    } else {

                        // if parent is set we should get the parent folder and add children to it

                        //alertWarning("getting folder " + globalCurrentParent);

                        var f = thisObject.getFolder(globalCurrentParent);
                        if (f == null) {
                            esbwarning("Folder is not available in the file browser", TYPE_WARN);
                            return;
                        }

                        var i = 0;
                        for (i = 0; i < entries.length; i++) {

                            var key;
                            var type;
                            if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                                key = entries[i].getElementsByTagName("key")[0].textContent;
                                type = entries[i].getElementsByTagName("type")[0].textContent;
                            } else {
                                key = entries[i].getElementsByTagName("key")[0].text;
                                type = entries[i].getElementsByTagName("type")[0].text;
                            }

                            var child;
                            if (type == "folder") {
                                child = new folder(key, key, thisObject.np);
                            } else {
                                child = new regfile(key, key, thisObject.np);
                            }

                            f.add(child);
                        }
                    }

                }
            }
        }

        thisObject.write();

        if (globalCurrentParent != null && globalCurrentParent != "" && fillOnly == "false") {
            thisObject.expand(globalCurrentParent);
        }

        if (globalCurrentParent != null && fillOnly == "true") {
            var f = globalCurrentParent;

            var i;
            if (globalIndex < keyPath.length - 1) {
                globalIndex++;
                i = globalIndex;
            } else {
                thisObject.expand(f);
                var oldEntry = document.getElementById('l' + thisObject.np + thisObject.selected);
                if (oldEntry != null) {
                    oldEntry.style.backgroundColor = '#ffffff';
                }

                globalIndex++;
                i = globalIndex;
                if (f == "") {
                    f = keyPath[i-1];
                } else {
                    f = f + "/" + keyPath[i-1];
                }

                var newEntry = document.getElementById('l' + thisObject.np + f);
                if (newEntry != null) {
                    newEntry.style.backgroundColor = '#9999ff';
                }

                thisObject.selected = f;
                thisObject.folderSelectHandler(f);
                return;
            }

            if (f == "") {
                f = keyPath[i-1];
            } else {
                f = f + "/" + keyPath[i-1];
            }

            thisObject.populatedFolders[thisObject.populatedFolders.length] = f;
            thisObject.populateChildren(f, thisObject.regDivName, "");
        }

    } else {
        //registryKeyDiv.innerHTML = "<input type='text' id='propertyKey' />";
    }
}

/* utility functions */

function showFolder(folder) {
    var objFolder = document.getElementById(thisObject.np + folder).style;
    objFolder.display="block";
    var objExpanderImg = document.getElementById('E' + thisObject.np + folder);
    objExpanderImg.src = expandedImg.src;
    var objFolderImg = document.getElementById('FI' + thisObject.np + folder);
    if (objFolderImg != null) {
        objFolderImg.src = folderopenImg.src;
    }
}

function hideFolder(folder){
    var objFolder = document.getElementById(thisObject.np + folder).style;
    objFolder.display="none";
    var objExpanderImg = document.getElementById('E' + thisObject.np + folder);
    objExpanderImg.src = collapsedImg.src;
    var objFolderImg = document.getElementById('FI' + thisObject.np + folder);
    if (objFolderImg != null) {
        objFolderImg.src = foldercloseImg.src;
    }
}

function containsStringRoot(array, string) {

    var i = 0;
    for(i = 0; i < array.length; i++) {
        if (array[i] == string)
            return true;
    }

    return false;
}
