<!--
  ~ Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="syn:endpoint" xmlns:syn="http://ws.apache.org/ns/synapse">
        <xsl:element name="div">
           <xsl:attribute name="id"><xsl:value-of select="concat('esb_endpoint_div',@index)"/></xsl:attribute>
           <xsl:attribute name="style">width:500px;</xsl:attribute>
            <label class="content-header">
                <img src="extensions/core/images/address_endpoint.gif"/>
                <xsl:text> Address Endpoint </xsl:text>
            </label>
            <xsl:if test="@index != 0 ">
            <xsl:element name="img">
                <xsl:attribute name="style">margin-left:15px</xsl:attribute>
                <xsl:attribute name="src">
                    extensions/core/images/delete.gif</xsl:attribute>
                <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                <xsl:attribute name="onClick">
                    javascript:deleteChildEndpoint('<xsl:value-of select="@index"/>');return false;
                </xsl:attribute>
            </xsl:element>
            </xsl:if>
            <br/>
            <br/>
            <div id="endpoint_edit" class="end-point-div">
                <br/>
                <table border="0" class="tabelcontainer">
                    <tbody>
                        <xsl:if test="@anonymous = 'false' ">
                         <tr>
                                <td>
                                   Name<font style='color: red;font-size: 8pt;'>&#160;*</font>
                                </td>
                                <td>
                                    <xsl:element name="input">
                                        <xsl:attribute name="id"><xsl:value-of select="concat('endpoint_name',@index)"/></xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                       <xsl:attribute name="value">
                                         <xsl:value-of select="@name"/>
                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                        </tr>
                        </xsl:if>
                        <tr>
                                <td>
                                    Address<font style='color: red;font-size: 8pt;'>&#160;*</font>
                                </td>
                                <td>
                                     <xsl:element name="input">
                                        <xsl:attribute name="id"><xsl:value-of select="concat('endpoint_address',@index)"/></xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                        <xsl:attribute name="value">
                                          <xsl:value-of select="syn:address/@uri"/>
                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                        </tr>
                        <tr>
                                <td>
                                    <xsl:text>Format</xsl:text>
                                </td>
                                 <td>
                                     <xsl:element name="select">
                                         <xsl:attribute name="onchange">
                                             javascript:onformatchange('<xsl:value-of select="@index"/>');
                                         </xsl:attribute>
                                        <xsl:attribute name="id"><xsl:value-of select="concat('endpoint_format',@index)"/></xsl:attribute>
                                          <xsl:attribute name="class">esb-edit</xsl:attribute>
                                            <xsl:if test="syn:address/@format ='pox'">
                                             <option value="POX">Plain Old XML (POX)</option>
                                             <option value="SOAP">Simple Object Access Protocol (SOAP)</option>
                                            </xsl:if>
                                            <xsl:if test="syn:address/@format ='soap'">
                                             <option value="SOAP">Simple Object Access Protocol (SOAP)</option>
                                             <option value="POX">Plain Old XML (POX)</option>
                                            </xsl:if>
                                            <xsl:if test="not(syn:address/@format)">
                                             <option value="Select A Value">Leave As-Is</option>
                                             <option value="SOAP">Simple Object Access Protocol (SOAP)</option>
                                             <option value="POX">Plain Old XML (POX)</option>
                                            </xsl:if>

                                    </xsl:element>
                                </td>
                        </tr>
                        <tr>
                                <td>
                                    <xsl:text>Optimize</xsl:text>
                                </td>
                               <td>  <xsl:element name="select">
                                        <xsl:attribute name="id"><xsl:value-of select="concat('endpoint_optimize',@index)"/></xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                            <xsl:if test="syn:address/@optimize ='mtom'">
                                                 <option value="MTOM">MTOM</option>
                                                <option value="SwA">SwA</option>
                                            </xsl:if>
                                            <xsl:if test="syn:address/@optimize ='swa'">
                                           <option value="SwA">SwA</option>
                                        <option value="MTOM">MTOM</option>
                                            </xsl:if>
                                           <xsl:if test="not(syn:address/@optimize)">
                                             <option value="Select A Value">Leave As-Is</option>
                                            <option value="SwA">SwA</option>
                                        <option value="MTOM">MTOM</option>
                                            </xsl:if>
                                        </xsl:element>
                                </td>
                         </tr>
                        <tr>
                            <td>
                                <xsl:text>Suspend </xsl:text>
                            </td>
                              </tr>
                        <tr>
                             <td style="padding-left:60px;">
                                    <xsl:text>Duration (Secs)</xsl:text>
                                </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('endpoint_suspend_duration',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="type">text</xsl:attribute>
                                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:if test="syn:address/syn:suspendDurationOnFailure">
                                            <xsl:variable name="duration"><xsl:value-of
                                                    select="syn:address/syn:suspendDurationOnFailure"/></xsl:variable>
                                            <xsl:value-of select="$duration"/>
                                        </xsl:if>
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>
                          <tr>
                                <td>
                                    <xsl:text>Timeout</xsl:text>
                                </td>
                          </tr>
                        <tr>
                            <td style="padding-left:60px;">
                                <xsl:text>Action</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="select">
                                    <xsl:attribute name="onchange">
                                        javascript:onActionChange('<xsl:value-of select="@index"/>');
                                    </xsl:attribute>
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('endpoint_timeout_action',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                                    <xsl:if test="syn:address/syn:timeout/syn:action/child::text() ='discard'">
                                        <option value="discard">Discard message</option>
                                        <option value="fault">Execute fault sequence</option>
                                        <option value="Select A Value">Never timeout</option>
                                    </xsl:if>
                                    <xsl:if test="syn:address/syn:timeout/syn:action/child::text() ='fault'">

                                        <option value="fault">Execute fault sequence</option>
                                        <option value="Select A Value">Never timeout</option>
                                        <option value="discard">Discard message</option>
                                    </xsl:if>
                                    <xsl:if test="not(syn:address/syn:timeout/syn:action/child::text() ='discard') and not(syn:address/syn:timeout/syn:action/child::text() ='fault')">
                                        <option value="Select A Value">Never timeout</option>
                                        <option value="discard">Discard message</option>
                                        <option value="fault">Execute fault sequence</option>
                                    </xsl:if>
                                </xsl:element>
                            </td>

                        </tr>
                        <tr>
                            <td style="padding-left:60px;">
                                <xsl:text>Duration (Secs)</xsl:text>
                            </td>
                            <td>
                                     <xsl:element name="input">
                                        <xsl:attribute name="id"><xsl:value-of select="concat('endpoint_duration',@index)"/></xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                        <xsl:attribute name="value">
                                            <xsl:if test="syn:address/syn:timeout">
                                                <xsl:value-of select="syn:address/syn:timeout/syn:duration"></xsl:value-of>
                                            </xsl:if>
                                             <xsl:if test="not(syn:address/syn:timeout)">
                                            <xsl:text>0</xsl:text>
                                            </xsl:if>
                                        </xsl:attribute>
                                         <xsl:attribute name="disabled">
                                             true
                                         </xsl:attribute>
                                    </xsl:element>
                           </td>
                        </tr>
                         <tr>
                            <td>
                                <xsl:text>WS-Addressing</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="type">checkbox</xsl:attribute>
                                    <xsl:attribute name="id"><xsl:value-of select="concat('wsAddressingEngaged',@index)"/></xsl:attribute>
                                        <xsl:choose>
                                            <xsl:when test="syn:address/@format ='pox'">
                                                <xsl:attribute name="disabled">
                                                    true
                                                </xsl:attribute>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:if test="syn:address/syn:enableAddressing">
                                                <xsl:attribute name="checked">
                                                    checked</xsl:attribute>
                                                 </xsl:if>
                                            </xsl:otherwise>
                                        </xsl:choose>

                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <xsl:text>WS-Security</xsl:text>
                            </td>
                            <td>
                               <xsl:element name="input">
                                    <xsl:attribute name="type">checkbox</xsl:attribute>
                                    <xsl:attribute name="id"><xsl:value-of select="concat('wsSecEngaged',@index)"/></xsl:attribute>
                                    <xsl:choose>
                                        <xsl:when test="syn:address/@format ='pox'">
                                            <xsl:attribute name="disabled">
                                                true
                                            </xsl:attribute>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:if test="syn:address/syn:enableSec">
                                                <xsl:attribute name="checked">
                                                    checked</xsl:attribute>
                                            </xsl:if>
                                        </xsl:otherwise>
                                    </xsl:choose>
                                   <xsl:attribute name="onClick">
                                        javascript:onwssecchange('<xsl:value-of select="@index"/>');
                                    </xsl:attribute>
                               </xsl:element>
                            </td>
                            </tr>
                            <tr>
                                <td style="padding-left:60px;">
                                    <xsl:text>Policy key</xsl:text>
                                </td>
                                <td>
                                    <xsl:element name="input">
                                        <xsl:attribute name="id"><xsl:value-of select="concat('sec_policy',@index)"/></xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                                        <xsl:attribute name="value">
                                               <xsl:if test="syn:address/syn:enableSec">
                                             <xsl:value-of select="syn:address/syn:enableSec/@policy"/>
                                            </xsl:if>
                                           </xsl:attribute>
                                        <xsl:attribute name="DISABLED"/>
                                    </xsl:element>
                                </td>
                                <td>
                                    <xsl:element name="img">
                                        <xsl:attribute name="src">
                                            extensions/core/images/registry_picker.gif</xsl:attribute>
                                        <xsl:attribute name="title">Registry Browser</xsl:attribute>
                                        <xsl:attribute name="onClick">
                                            javascript:policyfromregistry('<xsl:value-of select="@index"/>','SEC','Address','<xsl:value-of select="@anonymous"/>');return false;
                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                                </tr>

                        <tr>
                            <td>
                                <xsl:text>WS-RM</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="type">checkbox</xsl:attribute>
                                    <xsl:attribute name="id"><xsl:value-of select="concat('wsRMEngaged',@index)"/></xsl:attribute>
                                       <xsl:choose>
                                        <xsl:when test="syn:address/@format ='pox'">
                                            <xsl:attribute name="disabled">
                                                true
                                            </xsl:attribute>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:if test="syn:address/syn:enableRM">
                                                <xsl:attribute name="checked">
                                                    checked</xsl:attribute>
                                            </xsl:if>
                                        </xsl:otherwise>
                                    </xsl:choose>                                    
                                     <xsl:attribute name="onClick">
                                        javascript:onwsrmchange('<xsl:value-of select="@index"/>');
                                    </xsl:attribute>
                                 </xsl:element>
                            </td>
                            </tr>
                            <tr>
                                <td style="padding-left:60px;">
                                    <xsl:text>Policy key</xsl:text>
                                </td>
                                <td>
                                    <xsl:element name="input">
                                        <xsl:attribute name="id"><xsl:value-of select="concat('rm_policy',@index)"/></xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                                        <xsl:attribute name="value">
                                            <xsl:if test="syn:address/syn:enableRM">
                                             <xsl:value-of select="syn:address/syn:enableRM/@policy"/>
                                            </xsl:if>
                                        </xsl:attribute>
                                         <xsl:attribute name="DISABLED"/>
                                    </xsl:element></td>
                                <td>
                                    <xsl:element name="img">
                                        <xsl:attribute name="src">
                                            extensions/core/images/registry_picker.gif</xsl:attribute>
                                        <xsl:attribute name="title">Registry Browser</xsl:attribute>
                                        <xsl:attribute name="onClick">
                                            javascript:policyfromregistry('<xsl:value-of select="@index"/>','RM','Address','<xsl:value-of select="@anonymous"/>');return false;
                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                                </tr>
                    </tbody>
                </table>
            </div>
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>