<!--
  ~ Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:RMSequence"  xmlns:syn="http://ws.apache.org/ns/synapse">
       <div id="RMSequence_edit_div">
           <label class="content-header">
                <img src="extensions/core/images/property-mediator.gif"/>
                <xsl:text>Reliable Messaging Sequence Mediator</xsl:text>
            </label>
           <br/><br/>
           <table border="0">
               <tr>
                   <td>WS-RM Spec Version</td>
                   <td>
                       <input id="v1.0" type="radio" name="version">
                           <xsl:if test="@version='1.0'or not(@version='1.1')">
                               <xsl:attribute name="checked">
                                   true
                               </xsl:attribute>
                           </xsl:if>
                       </input>
                   </td>
                   <td>1.0</td>
                   <td>
                       <input id="v1.1" type="radio" name="version" disabled="true">
                           <xsl:if test="@version='1.1'">
                               <xsl:attribute name="checked">
                                   true
                               </xsl:attribute>
                           </xsl:if>
                       </input>
                   </td>
                   <td>1.1</td>
               </tr>


               <tr>
                   <td>Message sequence</td>
                   <td>
                       <input id="singleRadio" type="radio" name="messageType">
                           <xsl:if test="@single or not(@correlation)">
                               <xsl:attribute name="checked">
                                   true
                               </xsl:attribute>
                           </xsl:if>
                           <xsl:attribute name="onclick">javascript:hideCorrelationPanel();</xsl:attribute>
                       </input>
                   </td>
                   <td>Single message</td>
                   <td>
                       <input id="correlationRadio" type="radio" name="messageType">
                           <xsl:if test="@correlation">
                               <xsl:attribute name="checked">
                                   true
                               </xsl:attribute>
                           </xsl:if>
                           <xsl:attribute name="onclick">javascript:showCorrelationPanel();</xsl:attribute>
                       </input>
                   </td>
                   <td>Correlated sequence</td>
               </tr>
           </table>


           <div id="correlationPanel">
           <xsl:if test="@single or not(@correlation)">
               <xsl:attribute name="style">display:none</xsl:attribute>
           </xsl:if>
           <table>
               <tr>
                   <td/>
                   <td>
                       Sequence XPath<font style='color: red;font-size: 8pt;'>&#160;*</font>
                   </td>
                   <td>
                       <input id="correlation" type="text" class="esb-edit">
                           <xsl:attribute name="value">
                               <xsl:value-of select="@correlation"/>
                           </xsl:attribute>
                       </input>
                   </td>
                   <td>
                       <a title="Namespace Editor" class="ns_editor">
                           <xsl:attribute name="onclick">
                               javascript:showNameSpaceEditor('<xsl:value-of select="@esb_med_pos"/>','','');
                           </xsl:attribute>
                           <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                       </a>
                   </td>
               </tr>
               <tr>
                   <td/>
                   <td>
                       Last message XPath
                   </td>
                   <td>
                       <input id="last-message" type="text" class="esb-edit">
                           <xsl:attribute name="value">
                               <xsl:value-of select="@last-message"/>
                           </xsl:attribute>
                       </input>
                   </td>
                   <td>
                       <a title="Namespace Editor" class="ns_editor">
                           <xsl:attribute name="onclick">
                               javascript:showNameSpaceEditor('<xsl:value-of select="syn:reason/@esb_med_pos"/>','','');
                           </xsl:attribute>
                           <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                       </a>
                   </td>
               </tr>
           </table>
           </div>

       </div>
    </xsl:template>
</xsl:stylesheet>
