<!--
  ~ Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="mediator_view.xsl"/>

    <xsl:template match="syn:case" xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header"><img src="extensions/core/images/switch-mediator.gif"/> Switch Case</label>

        <br/>
        <br/>

        <label style="margin-left:3em;"> Case Regular Expression </label>
        <input type="text" style="margin-left: 8em;" id="regex_val" class="esb-edit">
            <xsl:attribute name="value"><xsl:value-of select="@regex"/></xsl:attribute>
        </input>

        <div class="indent"><xsl:apply-templates/></div>

        <xsl:if test="count(child::*)=0">
            <xsl:call-template name="add_mediator_control">
                <xsl:with-param name="head_pos" select="concat(@esb_med_pos, '.0')"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>
    
</xsl:stylesheet>