<!--
  ~ Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="commons.xsl"/>
    <xsl:template match="syn:send" xmlns:syn="http://ws.apache.org/ns/synapse">
        <xsl:variable name="position" select="@esb_med_pos"/>
        <div id="ep">
            <label class="content-header">
                <img src="extensions/core/images/send-mediator.gif"/>
                <xsl:text>Send Mediator</xsl:text>
            </label>
            <br/>
            <br/>
            <xsl:if test="syn:endpoint">
                <xsl:for-each select="syn:endpoint">
                    <div id="send_edit_div" class="end-point-div">
                        <br/>
                        <xsl:if test="@key">
                            <div>
                                <label class="content-header">
                                    <img src="extensions/core/images/look_up_endpoint.gif"/>
                                    <xsl:text>Lookup Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                 <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:address">
                            <div>
                                <label class="content-header">
                                <img src="extensions/core/images/address_endpoint.gif"/>
                                <xsl:text>Address Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:wsdl">
                             <div>
                                <label class="content-header">
                                <img src="extensions/core/images/wsdl_endpoint.gif"/>
                                <xsl:text>WSDL Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                  <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:loadbalance">
                             <div>
                                <label class="content-header">
                                <img src="extensions/core/images/load_balance_endpoint.gif"/>
                                <xsl:text>Load-balance Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                  <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:failover">
                           <div>
                                <label class="content-header">
                                <img src="extensions/core/images/failover_endpoint.gif"/>
                                <xsl:text>Failover Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                    </div>
                </xsl:for-each>
            </xsl:if>
            <xsl:if test="not(syn:endpoint)">
                <div>
                    <xsl:element name="img">
                        <xsl:attribute name="src">extensions/core/images/add.gif</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                        <xsl:attribute name="onClick">
                            javascript:addSendMediatorEndpointmenu(event,'<xsl:value-of select="$position"/>');return false;
                        </xsl:attribute>
                    </xsl:element>
                    <label class='styled-link'>Add Endpoint</label>
                </div>
            </xsl:if>
        </div>
    </xsl:template>
</xsl:stylesheet>