<!--
  ~ Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~      http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse">

    <xsl:template match="syn:proxy">
        <label class="content-header">
            <img src="extensions/core/images/target-configuration.gif"/>
            <xsl:text> Target configuration</xsl:text>
        </label>
        <!--<label class="content-description">-->
            <!--Define how messages arriving and departing through this proxy service should be handled. Available-->
            <!--options are to directly route messages to an endpoint; or to process incoming and outgoing messages-->
            <!--through already defined sequences of mediation.-->
        <!--</label>-->
        <br/><br />
        <label style='font-weight:bold;'>Target Sequences</label>
        <br/>
        <br/>
        <table>
            <xsl:if test="syn:target/@inSequence or syn:target/syn:inSequence">
                <!--<div id="target_insequence">-->
                    <tr>
                        <td style="margin-left: 15px; width:250px; _width:280px;" align="left">
                            <label>Incoming messages</label>
                        </td>

                        <xsl:if test="syn:target/@inSequence">
                            <td style="margin-left: 60px;" align="left">
                                <label id="insequence_label">
                                    <xsl:value-of select="syn:target/@inSequence"/>
                                </label>
                            </td>
                        </xsl:if>

                        <xsl:if test="syn:target/syn:inSequence">
                            <td>
                                <label id="insequence_label">Specified as anonymous</label>
                            </td>
                        </xsl:if>
                    </tr>
                <!--</div>-->
            </xsl:if>

            <xsl:if test="syn:target/@outSequence or syn:target/syn:outSequence">
                <!--<div id="target_outsequence">-->
                <tr>
                    <td style="margin-left: 15px; width:250px; _width:280px;" align="left">
                        <label>Outgoing messages</label>
                    </td>

                    <xsl:if test="syn:target/@outSequence">
                        <td style="margin-left: 60px;" align="left">
                            <label id="outsequence_label">
                                <xsl:value-of select="syn:target/@outSequence"/>
                            </label>
                        </td>
                    </xsl:if>
                    
                    <xsl:if test="syn:target/syn:outSequence">
                        <td>
                            <label id="outsequence_label">Specified as anonymous</label>
                        </td>
                    </xsl:if>
                </tr>
                <!--</div>-->
            </xsl:if>

            <xsl:if test="syn:target/@faultSequence or syn:target/syn:faultSequence">
                <!--<div id="target_faultsequence">-->
                <tr>
                    <td style="margin-left: 15px; width:250px; _width:280px;" align="left">
                        <label>Fault flow</label>
                    </td>

                    <xsl:if test="syn:target/@faultSequence">
                        <td style="margin-left: 60px;" align="left">
                            <label id="faultsequence_label">
                                <xsl:value-of select="syn:target/@faultSequence"/>
                            </label>
                        </td>
                    </xsl:if>

                    <xsl:if test="syn:target/syn:faultSequence">
                        <td>
                            <label id="faultsequence_label">Specified as anonymous</label>
                        </td>
                    </xsl:if>
                </tr>
                <!--</div>-->
            </xsl:if>
        </table>

        <table style="margin-left:-15px;">
            <xsl:if test="syn:target/@endpoint or syn:target/syn:endpoint">
                <tr>
                    <td style="width:265px; _width:280px;" align="left">
                        <label style='font-weight:bold;'>Target endpoint</label>
                    </td>
                    <td>
                        <xsl:if test="syn:target/@endpoint">
                            <label id="endpoint_label">
                                <xsl:value-of select="syn:target/@endpoint"/>
                            </label>
                        </xsl:if>
                        <xsl:if test="syn:target/syn:endpoint">
                            <label id="endpoint_label">Specified as annonymous</label>
                        </xsl:if>
                    </td>
                </tr>
            </xsl:if>
        </table>
        <br/>
        <br/>
        
    </xsl:template>

</xsl:stylesheet>